Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| The Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.jdbc.datasource
Class DriverManagerDataSource

    java.lang.Object
      org.springframework.jdbc.datasource.AbstractDataSource
          org.springframework.jdbc.datasource.AbstractDriverBasedDataSource
              org.springframework.jdbc.datasource.DriverManagerDataSource

All Implemented Interfaces:
  Wrapper, CommonDataSource, DataSource

Direct Known Subclasses:
  SingleConnectionDataSource

    public class DriverManagerDataSource

extends AbstractDriverBasedDataSource

Simple implementation of the standard JDBC `DataSource` interface, configuring the plain old JDBC `DriverManager` via bean properties, and returning a new `Connection` from every `getConnection` call.

NOTE: This class is not an actual connection pool; it does not actually pool Connections. It just serves as simple replacement for a full-blown connection pool, implementing the same standard interface, but creating new Connections on every call.

Useful for test or standalone environments outside of a J2EE container, either as a DataSource bean in a corresponding ApplicationContext or in conjunction with a simple JNDI environment. Pool-assuming `Connection.close()` calls will simply close the Connection, so any DataSource-aware persistence code should work.

NOTE: Within special class loading environments such as OSGi, this class is effectively superseded by `SimpleDriverDataSource` due to general class loading issues with the JDBC DriverManager that be resolved through direct Driver usage (which is exactly what SimpleDriverDataSource does).

In a J2EE container, it is recommended to use a JNDI DataSource provided by the container. Such a DataSource can be exposed as a DataSource bean in a Spring ApplicationContext via `JndiObjectFactoryBean`, for seamless switching to and from a local DataSource bean like this class. For tests, you can then either set up a mock JNDI environment through Spring's `SimpleNamingContextBuilder`, or switch the bean definition to a local DataSource (which is simpler and thus recommended).

If you need a "real" connection pool outside of a J2EE container, consider Apache's Jakarta Commons DBCP or C3P0. Commons DBCP's BasicDataSource and C3P0's ComboPooledDataSource are full connection pool beans, supporting the same basic properties as this class plus specific settings (such as minimal/maximal pool size etc).

Since:
  14.03.2003
Author:
  Juergen Hoeller
See Also:
  `SimpleDriverDataSource`

Field Summary

Fields inherited from class org.springframework.jdbc.datasource.AbstractDataSource
`logger`

Constructor Summary
`DriverManagerDataSource()` Constructor for bean-style configuration.
`DriverManagerDataSource(String url)` Create a new DriverManagerDataSource with the given JDBC URL, not specifying a username or password for JDBC access.
`DriverManagerDataSource(String url, Properties conProps)` Create a new DriverManagerDataSource with the given JDBC URL, not specifying a username or password for JDBC access.
`DriverManagerDataSource(String url, String username, String password)` Create a new DriverManagerDataSource with the given standard DriverManager parameters.
`DriverManagerDataSource(String driverClassName, String url, String username, String password)` Deprecated. since Spring 2.5. DriverManagerDataSource is primarily intended for accessing pre-registered JDBC drivers. If you need to register a new driver, consider using `SimpleDriverDataSource` instead.

Method Summary
`protected Connection` | `getConnectionFromDriver(Properties props)` Obtain a Connection using the given properties.
`protected Connection` | `getConnectionFromDriverManager(String url, Properties props)` Getting a Connection using the nasty static from DriverManager is extracted into a protected method to allow for easy unit testing.
`void` | `setDriverClassName(String driverClassName)` Set the JDBC driver class name.

Methods inherited from class org.springframework.jdbc.datasource.AbstractDriverBasedDataSource
`getConnection, getConnection, getConnectionFromDriver, getConnectionProperties, getPassword, getUrl, getUsername, setConnectionProperties, setPassword, setUrl, setUsername`

Methods inherited from class org.springframework.jdbc.datasource.AbstractDataSource
`getLoginTimeout, getLogWriter, isWrapperFor, setLoginTimeout, setLogWriter, unwrap`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### DriverManagerDataSource

    public DriverManagerDataSource()

  Constructor for bean-style configuration.

### DriverManagerDataSource

    public DriverManagerDataSource(String url)

  Create a new DriverManagerDataSource with the given JDBC URL, not specifying a username or password for JDBC access.

  Parameters:
    `url` - the JDBC URL to use for accessing the DriverManager
  See Also:
    `DriverManager.getConnection(String)`

### DriverManagerDataSource

    public DriverManagerDataSource(String url,
                                   String username,
                                   String password)

  Create a new DriverManagerDataSource with the given standard DriverManager parameters.

  Parameters:
    `url` - the JDBC URL to use for accessing the DriverManager
    `username` - the JDBC username to use for accessing the DriverManager
    `password` - the JDBC password to use for accessing the DriverManager
  See Also:
    `DriverManager.getConnection(String, String, String)`

### DriverManagerDataSource

    public DriverManagerDataSource(String url,
                                   Properties conProps)

  Create a new DriverManagerDataSource with the given JDBC URL, not specifying a username or password for JDBC access.

  Parameters:
    `url` - the JDBC URL to use for accessing the DriverManager
    `conProps` - JDBC connection properties
  See Also:
    `DriverManager.getConnection(String)`

### DriverManagerDataSource

    public DriverManagerDataSource(String driverClassName,
                                   String url,
                                   String username,
                                   String password)

  Deprecated. since Spring 2.5. DriverManagerDataSource is primarily intended for accessing pre-registered JDBC drivers. If you need to register a new driver, consider using `SimpleDriverDataSource` instead.

  Create a new DriverManagerDataSource with the given standard DriverManager parameters.

  Parameters:
    `driverClassName` - the JDBC driver class name
    `url` - the JDBC URL to use for accessing the DriverManager
    `username` - the JDBC username to use for accessing the DriverManager
    `password` - the JDBC password to use for accessing the DriverManager

Method Detail

### setDriverClassName

    public void setDriverClassName(String driverClassName)

  Set the JDBC driver class name. This driver will get initialized on startup, registering itself with the JDK's DriverManager.

  NOTE: DriverManagerDataSource is primarily intended for accessing pre-registered JDBC drivers. If you need to register a new driver, consider using `SimpleDriverDataSource` instead. Alternatively, consider initializing the JDBC driver yourself before instantiating this DataSource. The "driverClassName" property is mainly preserved for backwards compatibility, as well as for migrating between Commons DBCP and this DataSource.

  See Also:
    `DriverManager.registerDriver(java.sql.Driver)`, `SimpleDriverDataSource`

### getConnectionFromDriver

    protected Connection getConnectionFromDriver(Properties props)
                                          throws SQLException

  Description copied from class: `AbstractDriverBasedDataSource`
  Obtain a Connection using the given properties.

  Template method to be implemented by subclasses.

  Specified by:
    `getConnectionFromDriver` in class `AbstractDriverBasedDataSource`
  Parameters:
    `props` - the merged connection properties
  Returns:
    the obtained Connection
  Throws:
    `SQLException` - in case of failure

### getConnectionFromDriverManager

    protected Connection getConnectionFromDriverManager(String url,
                                                        Properties props)
                                                 throws SQLException

  Getting a Connection using the nasty static from DriverManager is extracted into a protected method to allow for easy unit testing.

  Throws:
    `SQLException`
  See Also:
    `DriverManager.getConnection(String, java.util.Properties)`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| The Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002-2008 The Spring Framework.